<?php
namespace Teknisa\CADEST\Modules\Produto\Services;

use Teknisa\CADEST\Modules\Produto\Factories\Fiscal as FiscalFactory;
use Teknisa\CADEST\Modules\Produto\Services\ProdutoUtilities;

class Fiscal {

    protected $fiscalFactory;
    protected $produtoUtilities;

    public function __construct(FiscalFactory $fiscalFactory, ProdutoUtilities $produtoUtilities) {
        $this->fiscalFactory = $fiscalFactory;
        $this->produtoUtilities = $produtoUtilities;
    }
    
    public function deleteRelacproditgen($row) {
        if ($this->existsLivromagPadrao()) {
            $livroPdrão = $this->getLivromagPadrao();
            $params = array(
                "CDPRODUTO"=>$row['CDPRODUTO'],
                "CDLIVROMAG"=>$livroPdrão['CDLIVROMAG'],
                "NRORG"=>$this->produtoUtilities->getNrorg()
            );
            $this->fiscalFactory->deleteRelacproditgen($params);
        }
    }

    private function existsLivromagPadrao() {
        $livroPdrão = $this->getLivromagPadrao();
        if (empty($livroPdrão)) {
            return false;
        } else {
            return true;
        }
    }

    private function getLivromagPadrao() {
        $params = array('NRORG'=>$this->produtoUtilities->getNrorg());
        $livroPdrão = $this->fiscalFactory->getLivroPadrão($params);
        return $livroPdrão;
    }

    public function saveFiscal($row) {
        if (!empty($row['CDGENPROD']) && !empty($row['CDTPITEMPROD'])) {
            if ($this->existsLivromagPadrao()) {
                $this->saveRelacproditgen($row);
            }
        }
    }
    
    private function saveRelacproditgen($row) {
        $livroPdrão = $this->getLivromagPadrao();
        $paramsToSelect = array(
            "CDLIVROMAG"=>$livroPdrão['CDLIVROMAG'],
            "CDPRODUTO"=>$row['CDPRODUTO'],
            "NRORG"=>$this->produtoUtilities->getNrorg()
        );
        $relacproditgen = $this->fiscalFactory->getRelacproditgen($paramsToSelect); 
        $paramsToModify = array(
            "CDGENPROD"=>$row['CDGENPROD'],
            "CDTPITEMPROD"=>$row['CDTPITEMPROD'],
            "CDPRODUTO"=>$row['CDPRODUTO'],
            "CDLIVROMAG"=>$livroPdrão['CDLIVROMAG'],
            "NRORG"=>$this->produtoUtilities->getNrorg()
        );
        
        if (empty($relacproditgen)) {
            $this->fiscalFactory->insertRelacproditgen($paramsToModify);
        } else {
            $this->fiscalFactory->updateRelacproditgen($paramsToModify);
        }
    }

}